

/*
CREATE OR REPLACE DIRECTORY awr_reports_dir AS '/tmp/awr';
GRANT READ, WRITE ON DIRECTORY AWR_REPORTS_DIR TO dirceu.resende;
*/


set linesize 10000
set lines 10000
set long 9000
set pagesize 10000
set verify off


accept dt_inicio char prompt 'Data inicial do Relatrio (Formato DD/MM/YYYY HH24): '
accept dt_fim char prompt 'Data final do Relatrio (Formato DD/MM/YYYY HH24): '


select *
from dba_hist_snapshot 
where begin_interval_time >= to_date('&dt_inicio', 'DD/MM/YYYY HH24') 
and end_interval_time <= to_date('&dt_fim', 'DD/MM/YYYY HH24');



prompt -----------------------------------------------------------------------------------------------------



select MIN(snap_id) - 1 AS inicio, MAX(snap_id) + 1 AS fim 
from dba_hist_snapshot 
where begin_interval_time >= to_date('&dt_inicio', 'DD/MM/YYYY HH24') 
and end_interval_time <= to_date('&dt_fim', 'DD/MM/YYYY HH24');


accept id_relatorio_inicio number prompt 'ID do Primeiro Relatrio: '
accept id_relatorio_fim number prompt 'ID do Ultimo Relatrio: '


set serveroutput on size 1000000
DECLARE
  l_snap_start       NUMBER := &id_relatorio_inicio;
  l_snap_end         NUMBER := &id_relatorio_fim;
  l_dir              VARCHAR2(50) := 'AWR_REPORTS_DIR';
  
  l_last_snap        NUMBER := NULL;
  l_dbid             v$database.dbid%TYPE;
  l_instance_number  v$instance.instance_number%TYPE;
  l_file             UTL_FILE.file_type;
  l_file_name        VARCHAR(50);
  l_file_name        VARCHAR(50);
  l_dir_path         VARCHAR(50);

BEGIN
  SELECT dbid
  INTO   l_dbid
  FROM   v$database;

  SELECT instance_number
  INTO   l_instance_number
  FROM   v$instance;
  
  select DIRECTORY_PATH 
  INTO   l_dir_path
  from   dba_directories
  where  directory_name = 'AWR_REPORTS_DIR';
       
  FOR cur_snap IN (SELECT snap_id
                   FROM   dba_hist_snapshot
                   WHERE  instance_number = l_instance_number
                   AND    snap_id BETWEEN l_snap_start AND l_snap_end
                   ORDER BY snap_id)
  LOOP
    IF l_last_snap IS NOT NULL THEN

      dbms_output.put_line('Os arquivos foram gerados em :'||l_dir_path||'/awr_'|| l_last_snap || '_' || cur_snap.snap_id || '.htm'); 
      l_file := UTL_FILE.fopen(l_dir, 'awr_' || l_last_snap || '_' || cur_snap.snap_id || '.htm', 'w', 32767);          

     FOR cur_rep IN (SELECT output
                      FROM   TABLE(DBMS_WORKLOAD_REPOSITORY.awr_report_html(l_dbid, l_instance_number, l_last_snap, cur_snap.snap_id)))
      LOOP
        UTL_FILE.put_line(l_file, cur_rep.output);
      END LOOP;
      UTL_FILE.fclose(l_file);
    END IF;
    l_last_snap := cur_snap.snap_id;
  END LOOP;
  
EXCEPTION
  WHEN OTHERS THEN
    IF UTL_FILE.is_open(l_file) THEN
      UTL_FILE.fclose(l_file);
    END IF;
    RAISE; 
END;
/